package com.example.sam4s;

import com.example.sam4s.R;
import com.sam4s.printer.Sam4sBuilder;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager.LayoutParams;
import android.widget.Button;
import android.widget.TextView;

public class cl_Pagemode extends Activity {
static final int SEND_TIMEOUT = 10 * 1000;
    
    boolean exitActivity = false;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.pagemode);
        
        //check close port
        if(cl_Menu.mPrinter == null){
            finish();
            return ;
        }
    
        //default setting
        TextView text = (TextView)findViewById(R.id.editText_text);
        String value = getString(R.string.pagemode_edit_text);
        text.setText(value);
        
        text = (TextView)findViewById(R.id.editText_area_x);
        text.setText("100");
        
        text = (TextView)findViewById(R.id.editText_area_y);
        text.setText("100");
        
        text = (TextView)findViewById(R.id.editText_area_width);
        text.setText("300");

        text = (TextView)findViewById(R.id.editText_area_height);
        text.setText("300");
        
        //Registration ClickListener
        Button button = (Button)findViewById(R.id.button_print);
        button.setOnClickListener(new btnPagemodeClick());

        //hide keyboard
        this.getWindow().setSoftInputMode(LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if(keyCode == KeyEvent.KEYCODE_BACK){
            exitActivity = true;
        }
        
        return super.onKeyDown(keyCode, event);
    }
    
    class btnPagemodeClick implements View.OnClickListener {
		@Override
		public void onClick(View arg0) {
			printText();			
		}
    }
    
    private void printText(){
        TextView text = (TextView)findViewById(R.id.editText_text);
        if(text.getText().toString().isEmpty()){
        	cl_Main.showMsg("Error!\n\nNo Text", this);
            return ;
        }
        
        Sam4sBuilder builder = null;
        try{
            //create builder
            Intent intent = getIntent();
            //Builder
            builder = new Sam4sBuilder(
                    intent.getStringExtra("printername"), intent.getIntExtra("language", 0));

            //add command
            //addPageBegin
            builder.addPageBegin();
            
            //addPageArea
            builder.addPageArea(
                    getBuilderAreaX(),
                    getBuilderAreaY(),
                    getBuilderAreaWidth(),
                    getBuilderAreaHeight());
            
            //addText
            builder.addText(getBuilderText());

            //addPageEn
            builder.addPageEnd();
            
            //send builder data
            try{
            	cl_Menu.mPrinter.sendData(builder);
          
            }catch(Exception e){
            	cl_Main.showMsg(e.getLocalizedMessage(), this);
            }
        }catch(Exception e){
        	cl_Main.showMsg(e.getLocalizedMessage(), this);
        }
        
        //remove builder
        if(builder != null){
            try{
                builder.clearCommandBuffer();
                builder = null;
            }catch(Exception e){
                builder = null;
            }
        }
    }
    
    private int getBuilderAreaX() {
        TextView text = (TextView)findViewById(R.id.editText_area_x);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }
    
    private int getBuilderAreaY() {
        TextView text = (TextView)findViewById(R.id.editText_area_y);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }

    private int getBuilderAreaWidth() {
        TextView text = (TextView)findViewById(R.id.editText_area_width);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }
    
    private int getBuilderAreaHeight() {
        TextView text = (TextView)findViewById(R.id.editText_area_height);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }

    private String getBuilderText() {
        TextView text = (TextView)findViewById(R.id.editText_text);
        return text.getText().toString();
    }
}
