package com.example.sam4s;

import java.util.ArrayList;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

import com.example.sam4s.R;
import com.sam4s.printer.Sam4sFinder;
import com.sam4s.printer.Sam4sPrint;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.RadioGroup;

public class cl_SearchPrinter extends Activity implements OnItemClickListener, Runnable {
	protected static final int AUTO_HIDE_DELAY_MILLIS = 0;

	Sam4sFinder ef = new Sam4sFinder(); 
	static String SelectedEllix = null;
	
	private RadioGroup rgDeviceType;
	
	private ListView mListView;
	
	private int mSearchType = 0;
	
	private final int ACTIVITY_MAIN = 2918;
	private final int ACTIVITY_MENU = ACTIVITY_MAIN+1;
	
	final static int DISCOVERY_INTERVAL = 500;
	
	ArrayAdapter<String> mArrayAdapter;
    
    ScheduledExecutorService scheduler;
    ScheduledFuture<?> future;
    Handler handler = new Handler();
	
	@Override  
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.searchprinter);

		rgDeviceType = (RadioGroup)findViewById(R.id.radioGroup1);
		rgDeviceType.setOnCheckedChangeListener(mRadioCheck);     
		
		mListView = (ListView)findViewById(R.id.listView1);
		mListView.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
		mListView.setOnItemClickListener(this);
		
        //start find thread scheduler
        scheduler = Executors.newSingleThreadScheduledExecutor();
        
        //find start
        findStart();
	}
	
	@Override
    public void onDestroy() {
        super.onDestroy();
        
        //stop find
        if(future != null){
            future.cancel(false);
            while(!future.isDone()){
                try{
                    Thread.sleep(DISCOVERY_INTERVAL);
                }catch(Exception e){
                    break;
               }
            }
            future = null;
        }
        if(scheduler != null){
            scheduler.shutdown();
            scheduler = null;
        }
        //stop old finder
        while(true) {
            try{
                ef.stopSearch();
                break;
            }catch(Exception e){
                e.getStackTrace();
            }
        }
    }

	
	RadioGroup.OnCheckedChangeListener mRadioCheck = new RadioGroup.OnCheckedChangeListener() 
	{
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) 
		{
			if(group.getId() == R.id.radioGroup1)
			{				
				mListView.setAdapter(null);
				
				findStart();
			}
		}
	};
	
	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		try
		{			
			SelectedEllix = arg0.getItemAtPosition(arg2).toString();
			cl_Menu.mPrinter.closePrinter();
System.out.println(mSearchType + ":" + SelectedEllix);

			switch(rgDeviceType.getCheckedRadioButtonId())
			{
				//case Sam4sPrint.DEVTYPE_ETHERNET:
				case R.id.radio1:
					cl_Menu.mPrinter.openPrinter(Sam4sPrint.DEVTYPE_ETHERNET, SelectedEllix);
					break;
				//case Sam4sPrint.DEVTYPE_BLUETOOTH:				
				case R.id.radio0:			
					cl_Menu.mPrinter.openPrinter(Sam4sPrint.DEVTYPE_BLUETOOTH, SelectedEllix);
					break;
			}
			
			Intent MenuIntent = new Intent(getBaseContext(), cl_Menu.class);
			startActivityForResult(MenuIntent, ACTIVITY_MENU);     
			
			ef.stopSearch();
		}
		catch(Exception ex)
		{
			return;
		}
	}
	
    //find thread
	@Override
    public void run() {        
		class UpdateListThread extends Thread{
            String[] list;
            public UpdateListThread(String[] listDevices) {
                list = listDevices;
            }
            
            @Override
            public void run() {
            	try
            	{
	                if(list != null){
	                	ArrayList<String> mArrayList = new ArrayList<String>();             
	          
	                    for(String mDeviceFromList : list)
	                    {
	                    	if(mDeviceFromList != null)
	                    		mArrayList.add(mDeviceFromList);
	                    }
	                	
	                	mArrayAdapter = new ArrayAdapter<String>(getBaseContext(), android.R.layout.simple_list_item_1, mArrayList);
	                    
	                    mListView.setAdapter(mArrayAdapter);
	                    mArrayAdapter.notifyDataSetChanged();
	                }
	                
	                Thread.sleep(100);
            	}
            	catch(Exception ex)
            	{
            		cl_Main.showMsg(ex.getLocalizedMessage(), getBaseContext());
            	}
            }
        }
		
		String[] deviceList = null;
        try{
            deviceList = ef.getResult();
            handler.post(new UpdateListThread(deviceList));
        }catch(Exception e){
            return;
        }
    }
    
	private void findStart()
	{
		try
		{
			if(scheduler == null){
	            return;
	        }
	        
	        //stop old finder
	        while(true) {
	            try{
	                ef.stopSearch();
	                break;
	            }catch(Exception e){
	                e.getStackTrace();
	            }
	        }
	        
	        //stop find thread
	        if(future != null){
	            future.cancel(false);
	            while(!future.isDone()){
	                try{
	                    Thread.sleep(DISCOVERY_INTERVAL);
	                }catch(Exception e){
	                    break;
	                }
	            }
	            future = null;
	        }

	        //get device type and find
	        RadioGroup radioGroup = (RadioGroup)findViewById(R.id.radioGroup1);
	        try{
	        	ef.stopSearch();
	        	
	            switch(radioGroup.getCheckedRadioButtonId()){
		            case R.id.radio0:
		            	ef.startSearch(getBaseContext(), Sam4sFinder.DEVTYPE_BLUETOOTH);
		                break;
		            case R.id.radio1:
		            	ef.startSearch(getBaseContext(), Sam4sFinder.DEVTYPE_ETHERNET);
		                break;
		            /*case R.id.radio2:
		            	ef.startSearch(getBaseContext(), Sam4sFinder.DEVTYPE_SERIAL_SAP4K);
		                break;*/
	                default:
	                	ef.startSearch(getBaseContext(), Sam4sFinder.DEVTYPE_ETHERNET);
	                	break;
	            }
	        }catch(Exception e){
	        	cl_Main.showMsg(e.getLocalizedMessage(), this);
	            return ;
	        }

	        //start thread
	        future = scheduler.scheduleWithFixedDelay(this, 0, DISCOVERY_INTERVAL, TimeUnit.MILLISECONDS);
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			cl_Main.showMsg(ex.getLocalizedMessage(), this);
		}
	}
	
}
